screengrab.selection = {
	BACKGROUND_DIV : "screengrabBackgroundDiv",
	DRAW_DIV : "screengrabDrawDiv",
	BOX_DIV : "screengrabBoxDiv",
	IDLE_IMAGE : "url('chrome://screengrab/skin/idle.png') 0 no-repeat",
	SNAP_IMAGE : "url('chrome://screengrab/skin/snap.png') 0 no-repeat",
	TOOL_TEXT : "Grab/Cancel",
	oldText : null,

	originX : null,
	originY : null,
	mouseX : null,
	mouseY : null,
	offsetX : null,
	offsetY : null

};
//------------------------------------------------------------------------------
screengrab.selection.toggleDraw = function() {
	if (window.content.drawing) {
		screengrab.selection.disableDrawAndGrabIfRequired();
	} else {
		screengrab.selection.enableDraw();
	}
}
//------------------------------------------------------------------------------
screengrab.selection.insertHeaderElements = function() {
	var x = window.content;
	var pageHead = x.document.getElementsByTagName("head")[0];
    
	if (pageHead == null) { // if page head doesn't exist, create one
		var pageBody = x.document.getElementsByTagName("html")[0];
		pageHead = x.document.createElement("head");
		pageBody.appendChild(pageHead);
		pageHead = x.document.getElementsByTagName("head")[0];
	}
    
	var cssCheck = x.document.getElementById("screengrab_css");
    
	if (cssCheck == null) { // insert stylesheet reference
		var css = x.document.createElement("link");
		css.setAttribute("id", "screengrab_css");
		css.setAttribute("rel", "stylesheet");
		css.setAttribute("type", "text/css");
		css.setAttribute("href", "chrome://screengrab/skin/screengrab.css");
    
		pageHead.appendChild(css);
	}
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
screengrab.selection.beginBoxDraw = function(event) {
	var winCon = window.content;
	var boxDiv = winCon.document.getElementById(screengrab.selection.BOX_DIV);
	if (boxDiv == null) {
		boxDiv = winCon.document.createElement("div");
		boxDiv.setAttribute("id", screengrab.selection.BOX_DIV);
		boxDiv.setAttribute("class", "boxOverlay");
		var body = winCon.document.getElementsByTagName("html")[0];
		body.appendChild(boxDiv);
	}

	boxDiv.style.display = "none";
	boxDiv.style.left = event.pageX + "px";
	boxDiv.style.top = event.pageY + "px";
	winCon.document.addEventListener("mousemove", screengrab.selection.boxDrawing, true);
	winCon.document.addEventListener("mouseup", screengrab.selection.endBoxDraw, true);
	winCon.document.addEventListener("scroll", screengrab.selection.scrollBoxDraw, true);
	winCon.document.addEventListener("keydown", screengrab.selection.quitBoxDraw, true);

	screengrab.selection.originX = event.pageX;
	screengrab.selection.originY = event.pageY;

	screengrab.selection.mouseX = event.pageX;
	screengrab.selection.mouseY = event.pageY;

	screengrab.selection.offsetX = winCon.pageXOffset || winCon.document.documentElement.scrollLeft;
	screengrab.selection.offsetY = winCon.pageYOffset || winCon.document.documentElement.scrollTop;
}

screengrab.selection.boxDrawing = function(event) {
	var winCon = window.content;
	var boxDiv = winCon.document.getElementById(screengrab.selection.BOX_DIV);

	screengrab.selection.mouseX = event.pageX;
	screengrab.selection.mouseY = event.pageY;

	var left = screengrab.selection.mouseX < screengrab.selection.originX ? screengrab.selection.mouseX : screengrab.selection.originX;
	var top = screengrab.selection.mouseY < screengrab.selection.originY ? screengrab.selection.mouseY : screengrab.selection.originY;

	var width = Math.abs(screengrab.selection.mouseX - screengrab.selection.originX);
	var height = Math.abs(screengrab.selection.mouseY - screengrab.selection.originY);

	boxDiv.style.display = "none";
	boxDiv.style.left = left + "px";
	boxDiv.style.top = top + "px";

	boxDiv.style.width = width + "px";
	boxDiv.style.height = height + "px";
	boxDiv.style.display = "inline";

	var useZoom = screengrab.prefs.getBool('useZoom');
	var zoom_font = screengrab.Util.check_zoom();
	var zoom = (useZoom) ? zoom_font : 1;

	boxDiv.innerHTML = '<div style="font-size: ' +Math.round(14 / zoom_font) + 'px;"><nobr>w: ' + Math.round(width*zoom) + '; h: ' + Math.round(height*zoom) + '</nobr></div>';
}
screengrab.selection.scrollBoxDraw = function(event) {
	var winCon = window.content;
	var boxDiv = winCon.document.getElementById(screengrab.selection.BOX_DIV);

	if (boxDiv) {
		var scrollX = event.pageX;
		var scrollY = event.pageY;
		screengrab.selection.mouseX = screengrab.selection.mouseX + (scrollX - screengrab.selection.offsetX);
		screengrab.selection.mouseY = screengrab.selection.mouseY + (scrollY - screengrab.selection.offsetY);
		screengrab.selection.offsetX = scrollX;
		screengrab.selection.offsetY = scrollY;
		var e = { 'pageX': screengrab.selection.mouseX, 'pageY': screengrab.selection.mouseY };
		screengrab.selection.boxDrawing(e);
	}
}
screengrab.selection.quitBoxDraw = function(e) {
	if (e.keyCode === 27 ) {
		screengrab.selection.endBoxDraw(e);
	}
}
screengrab.selection.endBoxDraw = function(event) {
	var winCon = window.content;
	winCon.document.removeEventListener("mousemove", screengrab.selection.boxDrawing, true);
	winCon.document.removeEventListener("mouseup", screengrab.selection.endBoxDraw, true);
	winCon.document.removeEventListener("scroll", screengrab.selection.scrollBoxDraw, true);
	winCon.document.removeEventListener("keydown", screengrab.selection.quitBoxDraw, true);
}
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
screengrab.selection.enableDraw = function() {
	var screengrabBar = window.document.getElementById("screengrab_bar");
	if (screengrabBar != null) {
		screengrabBar.style.background = screengrab.selection.SNAP_IMAGE;
		screengrab.selection.oldText = screengrabBar.tooltiptext;
		screengrabBar.tooltiptext = screengrab.selection.TOOL_TEXT;
    	}
    
	var winCon = window.content;
	screengrab.selection.insertHeaderElements();
    
	var body = winCon.document.getElementsByTagName("html")[0];
        
	var drawDiv = winCon.document.createElement("div");
	drawDiv.setAttribute("id", screengrab.selection.DRAW_DIV);
        
	var backgroundDiv = winCon.document.createElement("div");
	backgroundDiv.setAttribute("id",  screengrab.selection.BACKGROUND_DIV);
	backgroundDiv.setAttribute("class", "backgroundOverlay");
	backgroundDiv.addEventListener("mousedown", screengrab.selection.beginBoxDraw);
	backgroundDiv.innerHTML = '<span id="screengrab_bar_fx" style="cursor:pointer;" onclick="disableDraw();">press "ESC" to exit</span>';
	drawDiv.appendChild(backgroundDiv);
	body.appendChild(drawDiv);
        
	winCon.document.addEventListener("mouseup", screengrab.selection.OnMouseUpHandlerThatHasToExistForSomeReason, true);
	winCon.document.addEventListener("keydown", screengrab.selection.OnKeyDownHandler, true);
	window.content.drawing = true;
 }
//------------------------------------------------------------------------------
screengrab.selection.disableDrawAndGrabIfRequired = function(event) {
	var result = screengrab.selection.disableDraw(event);
	try {
		if (result.box != null && event != null) {
//			screengrab.selection.callback(result.dimBox);
			window.content.screengrab_callback(result.dimBox);
		}
	} catch (error) {
//		screengrab.error(error);
	}
}
//------------------------------------------------------------------------------
screengrab.selection.OnMouseUpHandlerThatHasToExistForSomeReason = function(event) {
	if (event.target.id == 'screengrab_bar_fx') {
		screengrab.selection.disableDraw(event);
	} else {
		screengrab.selection.disableDrawAndGrabIfRequired(event);
	}
}
//------------------------------------------------------------------------------
screengrab.selection.OnKeyDownHandler = function(event) {
	if (event.keyCode === 27 ) {
		screengrab.selection.disableDraw(event);
	}
}
//------------------------------------------------------------------------------
screengrab.selection.disableDraw = function(event) {
	try {
		window.content.document.removeEventListener("mouseup", screengrab.selection.OnMouseUpHandlerThatHasToExistForSomeReason, true);
	        window.content.document.removeEventListener("keydown", screengrab.selection.OnKeyDownHandler, true);
	} catch (error) {
	}
	var box = null;
	var dimBox = null;
	try {
		var winCon = window.content;
		var body = winCon.document.getElementsByTagName("html")[0];

		// create a box to hold the dimensions of the box
		box = winCon.document.getElementById( screengrab.selection.BOX_DIV);
		if (box && (box != null)) {
			dimBox = new screengrab.Box(box.offsetLeft, box.offsetTop, box.clientWidth, box.clientHeight)
			// remove the box div
			body.removeChild(box);
		}
		var newDiv = winCon.document.getElementById(screengrab.selection.DRAW_DIV);
		if (newDiv) {
			body.removeChild(newDiv);
		}
	    	
		// restore the styling to the screengrab bar
		var screengrabBar = window.document.getElementById("screengrab_bar");
		if (screengrabBar != null) {
			screengrabBar.style.background = screengrab.selection.IDLE_IMAGE;
			screengrabBar.tooltiptext = screengrab.selection.oldText;
		}

		window.content.drawing = false;
	    } catch (error) {
		screengrab.error(error);
	}
	return { 'box' : box, 'dimBox' : dimBox};
}
//------------------------------------------------------------------------------
