screengrab.Upload_Imgur = {};
screengrab.Upload_Imgur.sid = null;
//------------------------------------------------------------------------------
screengrab.Upload_Imgur.doUpload = function(uploadAction, binaryInputStream, binaryInputStream_length) {
	var req = new XMLHttpRequest();
	//------------------------------------------------------------------
	var boundStr = '---------------------------' + new Date().getTime();
	var boundary = '--' + boundStr;
	if (screengrab.Upload_Imgur.sid == null) {
		screengrab.Upload_Imgur.sid = screengrab.Util.random_string(26);
	}
	var bodyStart = screengrab.setUploadBody(boundary, [
		{ 'param': 'layout', 'value': 'b' },
		{ 'param': 'current_upload', 'value': '1' },
		{ 'param': 'catify', 'value': '0' },
		{ 'param': 'sid', 'value': screengrab.Upload_Imgur.sid },
		{ 'param': 'edit', 'value': '0' },
		{ 'param': 'forceAnonymous', 'value': 'false' },
		{ 'param': 'total_uploads', 'value': '1' },
		{ 'param': 'gallery_submit', 'value': 'false' },
		{ 'param': 'gallery_type', 'value': '' },
		{ 'param': 'create_album', 'value': '0' },
		{ 'param': 'gallery_title', 'value': 'Gallery submission title (required)' },
		{ 'param': 'terms', 'value': '0' },
		{ 'param': 'album_title', 'value': 'Optional Album Title' }
	]);

	bodyStart += 'Content-Disposition: form-data; name="Filedata"; filename="' + screengrab.prefs.defaultFileName() + "." + uploadAction.formatImageExt + '"' + "\r\n";
	bodyStart += 'Content-Type: ' + uploadAction.formatMimeType + "\r\n" + "\r\n";

	var bodyStartStream = new sg.File.StringInputStream(bodyStart, bodyStart.length);
	var bodyEnd = "\r\n" + boundary + "--";
	var bodyEndStream = new sg.File.StringInputStream(bodyEnd, bodyEnd.length);

	var multiplexed = new sg.File.MultiplexInputStream();
	multiplexed.appendStream(bodyStartStream);
	multiplexed.appendStream(binaryInputStream);
	multiplexed.appendStream(bodyEndStream);

	var length = bodyStartStream.available() + binaryInputStream_length + bodyEndStream.available(); 
	req.open("POST", "http://imgur.com/upload", true);
	req.setRequestHeader("Content-type", "multipart/form-data; boundary=" + boundStr);
	req.setRequestHeader("Content-Length", length);
	req.setRequestHeader("Connection", "close");
	req.overrideMimeType('text/xml');

	req.onreadystatechange = function() {
		if (req.readyState == 4) {
			if (req.status == 200) {
				screengrab.Upload_Imgur.okUpload(req);
			} else {
				screengrab.errorUpload(req);
			}
		}
	}
	req.upload.onprogress = function(event) {
		if (event.lengthComputable) {
			var percent = Math.round(100 * event.loaded / event.total);
			screengrab.Util.setNotify(req.notificationBox, 'notifyTypeUpload', 'Upload screen... ' + percent + '%');
		}
	}

	req.notificationBox = screengrab.Util.notificationBoxGet('notifyTypeUpload');
	screengrab.Util.setNotify(req.notificationBox, 'notifyTypeUpload', 'Upload screen...');

	req.siteTitle = uploadAction.siteTitle;
	req.siteDescription = uploadAction.siteDescription;
	req.siteURL = uploadAction.siteURL;
	req.formatImageExt = uploadAction.formatImageExt;

	req.send(multiplexed);
}
//------------------------------------------------------------------------------
screengrab.Upload_Imgur.okUpload = function(req) {
	var jrsp = null;
	try {
		jrsp = JSON.parse(req.responseText);
	} catch (e) {
		screengrab.errorUpload(req);
		return;
	};

//	{"data":{"hashes":["MfObArV","vscc7rF","quZJngf"],"hash":"quZJngf","album":false,"edit":false,"gallery":null,"gallery_type":null},"success":true,"status":200}

	if (jrsp && jrsp.success && jrsp.data.hash) {
		screengrab.Util.setNotify(req.notificationBox, 'notifyTypeUpload', 'Screen is uploaded');
		gBrowser.selectedTab = gBrowser.addTab('http://imgur.com/' + jrsp.data.hash);
		screengrab.copyUploadLink('http://imgur.com/' + jrsp.data.hash + '.' + req.formatImageExt);
		return 1;
	}
	screengrab.errorUpload(req);
}
//------------------------------------------------------------------------------
